
var sourceNode = false;
var transferNodeAttributes = false;

/*  TARGET HANDLER */
var fncClassDragDropObserverTarget = 
	{
	getSupportedFlavours : function () 
		{
		var flavours = new FlavourSet();
		flavours.appendFlavour("text/unicode");
		return flavours;
		},

	onDragStart: function (evt,transferData,action)
		{
		sourceNode = evt.target;
		dump("Drag start target \n");
		txt = evt.target.getAttribute("label");
		dump("payload: " + txt + "\n");
		transferData.data=new TransferData();
		transferNodeAttributes = txt;
		dump("Removing from " + evt.target.parentNode.getAttribute('id') + "\n");
		//evt.target.parentNode.removeChild(evt.target);
		transferData.data.addDataForFlavour("text/unicode",txt);
		dump("Done source drag start  \n");
		},

	onDragOver: function (evt,flavour,session)
		{
		dump("Drag over target " + evt.target.nodeName + " \n");
		},

	onDrop: function (evt,dropdata,session)
		{				
		dump("DROP! Transfer is " + transferNodeAttributes + "\n");
		// Don't add childs to listitems, add to listbox
		var dropTarget = evt.target;
		dump("Target is " + dropTarget.nodeName + "\n");  
		if(dropTarget.nodeName == "textbox") return;
		if(dropTarget.nodeName == "listitem") {
			dump("Drop target modded to " + dropTarget.parentNode.nodeName + "\n");
			dropTarget = dropTarget.parentNode;
		}
	
		var newNodeAttributes = transferNodeAttributes;
	transferNodeAttributes = false;
		dump("Removing item from drag start box \n");
		sourceNode.parentNode.removeChild( sourceNode);
		sourceNode = false;
			
			var newNode = document.createElement("listitem");
			dump("new node is " + newNode + "\n");
			//newNode.setAttribute("value", newNodeAttributes[0]);
			newNode.setAttribute("label", newNodeAttributes);
			dump("adding\n");
			dropTarget.appendChild(newNode);

			}
	
};


/*  SOURCE HANDLER */
var fncClassDragDropObserverSource = 
	{
	getSupportedFlavours : function () 
		{
		var flavours = new FlavourSet();
		flavours.appendFlavour("text/unicode");
		return flavours;
		},

	onDragStart: function (evt,transferData,action)
		{
		sourceNode = evt.target;
		dump("Drag start source \n");
		txt =   evt.target.getAttribute("label");
		dump("payload: " + txt + "\n");
		transferData.data=new TransferData();
		transferNodeAttributes = txt;
		dump("Removing from " + evt.target.parentNode.getAttribute('id') + "\n");
		//evt.target.parentNode.removeChild(evt.target);
				transferData.data.addDataForFlavour("text/unicode",txt);
		dump("Done source drag start  \n");
		},

	onDragOver: function (evt,flavour,session)
		{
		//dump("Drag over source \n");
		},

	onDrop: function (evt,dropdata,session)
		{
		var dropTarget = evt.target;
		dump("Target is " + dropTarget.nodeName + "\n");
		// Don't add childs to listitems, add to listbox
		if(dropTarget.nodeName == "textbox") return;
		if(dropTarget.nodeName == "listitem") {
					dump("Listitem, droptarget revised to " + dropTarget.parentNode.nodeName + "\n");
			dropTarget = dropTarget.parentNode;

		}
		dump("Transfer is " + transferNodeAttributes + "\n");
		var newNodeAttributes = transferNodeAttributes;//.split(",");
	transferNodeAttributes = false;
	//dump(data[0] + " " + data[1] + "\n");
		sourceNode.parentNode.removeChild( sourceNode);
		sourceNode = false;
			dump("Drop on target with  " + dropdata + "\n");
			var newNode = document.createElement("listitem");
			dump("new node is " + newNode + "\n");
			newNode.setAttribute("value", newNodeAttributes);
			newNode.setAttribute("tooltiptext", newNodeAttributes);
	
			newNode.setAttribute("label", newNodeAttributes);
			dump("adding\n");
			dropTarget.appendChild(newNode);


			}
	
};

function addContainer() {
	catsDrawn++;
	var tempNode;
	
	row1count = document.getElementById("catsort-row-1").childNodes.length;
	row2count = document.getElementById("catsort-row-2").childNodes.length;
	dump("row counts " + row1count + " " + row2count +  " " + (row1count > row2count) + "\n");
	if(row1count > row2count) {row =  document.getElementById("catsort-row-2");dump("row 1\n"); }
	if(row1count <= row2count) { row =  document.getElementById("catsort-row-1");dump("row 1\n"); }

	tempNode = document.getElementById("dropcat-template").cloneNode(true);
	tempNode.setAttribute("id", "dropcat" + catsDrawn);
	tempLabelNode =getNameNodeFromDropCat(tempNode);
	tempLabelNode.setAttribute("id", "dropcat" + catsDrawn + "name");
	tempListBoxNode = getListboxFromDropCat(tempNode);
	tempListBoxNode.setAttribute("id", "dropcat" + catsDrawn + "list");
	//tempListBoxNode.setAttribute("ondragdop", "event.stopPropagation();event.preventDefault();dump('droppinz \n');nsDragAndDrop.drop(event,fncClassDragDropObserverTarget);");
	tempListBoxNode.setAttribute("ondraggesture", "nsDragAndDrop.startDrag(event,fncClassDragDropObserverTarget)");
	
/*ondragdrop="event.stopPropagation();dump('droppinz \n');nsDragAndDrop.drop(event,fncClassDragDropObserverTarget);event.preventDefault();" ondraggesture="nsDragAndDrop.startDrag(event,fncClassDragDropObserverTarget)" 
	*/
	tempNode.setAttribute("hidden", false);
	row.appendChild(tempNode);


}

function DragOverContainer ( event )
{
	dump("validating container  " + event.target.nodeName + " " + event.target.getAttribute("id") + "\n");
  var validFlavor = true;
  var dragSession = null;
                  
  var dragService =Components.classes[ "@mozilla.org/widget/dragservice;1"].getService();
if ( dragService ) {
    dragSession = dragService.getCurrentSession();
      /*if ( dragSession ) {
      if ( dragSession.isDataFlavorSupported("moz/toolbaritem") )
        validFlavor = true;
      else if ( dragSession.isDataFlavorSupported("text/plain") )
        validFlavor = true;
	  */
   if ( validFlavor && (event.target.nodeName == "listbox" || event.target.nodeName == "listitem")) {
     //var toolbar = document.getElementById("PersonalToolbar");
     event.target.setAttribute ( "dd-triggerrepaint", 0 );
     dragSession.canDrop = true;
	 dump("Drag session can drop " + dragSession.canDrop + "\n");
     event.preventBubble();
   } else {
   	   event.target.setAttribute ( "dd-triggerrepaint", 0 );
     dragSession.canDrop = false;
	 dump("Drag session cannot drop " + dragSession.canDrop + "\n");
     event.preventBubble();
   }
   }

} // DragOverPersonalToolbar